



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【Dubbo源码阅读系列】之 Dubbo XML 配置加载</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【Dubbo源码阅读系列】之 Dubbo XML 配置加载</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 18:13:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>今天我们来谈谈 Dubbo XML 配置相关内容。关于这部分内容我打算分为以下几个部分进行介绍：</p>
<ul><li>Dubbo XML</li>
<li>Spring 自定义 XML 标签解析</li>
<li>Dubbo 自定义 XML 标签解析</li>
<li>DubboBeanDefinitionParser.parse()</li>
<li>End</li></ul>
<h2>Dubbo XML</h2>
<p>在本小节开始前我们先来看下 Dubbo XML 配置文件示例：</p>
<pre class="prettyprint linenums"><code>dubbo-demo-provider.xml<br />
&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;<br />
&lt;!--<br />
&lt;beans xmlns:xsi=&quot;http://www.w3.org/2001/XMLSchema-instance&quot;<br />
       xmlns:dubbo=&quot;http://dubbo.apache.org/schema/dubbo&quot;<br />
       xmlns=&quot;http://www.springframework.org/schema/beans&quot;<br />
       xsi:schemaLocation=&quot;http://www.springframework.org/schema/beans http://www.springframework.org/schema/beans/spring-beans-4.3.xsd<br />
       http://dubbo.apache.org/schema/dubbo http://dubbo.apache.org/schema/dubbo/dubbo.xsd&quot;&gt;

    &lt;!-- provider's application name, used for tracing dependency relationship --&gt;<br />
    &lt;dubbo:application name=&quot;demo-provider&quot;/&gt;

    &lt;!-- use multicast registry center to export service --&gt;<br />
    &lt;!--&lt;dubbo:registry address=&quot;multicast://224.5.6.7:1234&quot;/&gt;--&gt;<br />
    &lt;dubbo:registry address=&quot;zookeeper://10.14.22.68:2181&quot;/&gt;

    &lt;!-- use dubbo protocol to export service on port 20880 --&gt;<br />
    &lt;dubbo:protocol name=&quot;dubbo&quot; port=&quot;20880&quot;/&gt;

    &lt;!-- service implementation, as same as regular local bean --&gt;<br />
    &lt;bean id=&quot;demoService&quot; class=&quot;org.apache.dubbo.demo.provider.DemoServiceImpl&quot;/&gt;

    &lt;!-- declare the service interface to be exported --&gt;<br />
    &lt;dubbo:service interface=&quot;org.apache.dubbo.demo.DemoService&quot; ref=&quot;demoService&quot;/&gt;<br />
&lt;/beans&gt;<br />
</code></pre>
<p>在这段配置文件中有一些以 dubbo 开头的 xml 标签，直觉告诉我们这种标签和 dubbo 密切相关。那么这些标签的用途是什么？又是如何被识别的呢？<br /><br />
我们结合 Spring 自定义 xml 标签实现相关内容来聊聊 Dubbo 是如何定义并加载这些自定义标签的。</p>
<h2>Spring 自定义 XML 标签解析</h2>
<p>Dubbo 中的自定义 XML 标签实际上是依赖于 Spring 解析自定义标签的功能实现的。网上关于 Spring 解析自定义 XML 标签的文章也比较多，这里我们仅介绍下实现相关功能需要的文件，给大家一个直观的印象，不去深入的对 Spring 自定义标签实现作详细分析。</p>
<ol><li><strong>定义 xsd 文件</strong><br /><br />
XSD(XML Schemas Definition) 即 XML 结构定义。我们通过 XSD 文件不仅可以定义新的元素和属性，同时也使用它对我们的 XML 文件规范进行约束。<br /><br />
在 Dubbo 项目中可以找类似实现：<strong>dubbo.xsd</strong></li>
<li><strong>spring.schemas</strong><br /><br />
该配置文件约定了自定义命名空间和 xsd 文件之间的映射关系，用于 spring 容器感知我们自定义的 xsd 文件位置。</li></ol>
<pre class="prettyprint linenums"><code>http\://dubbo.apache.org/schema/dubbo/dubbo.xsd=META-INF/dubbo.xsd<br />
http\://code.alibabatech.com/schema/dubbo/dubbo.xsd=META-INF/compat/dubbo.xsd<br />
</code></pre>
<ol><li><strong>spring.handlers</strong><br /><br />
该配置文件约定了自定义命名空间和 NamespaceHandler 类之间的映射关系。 NamespaceHandler 类用于注册自定义标签解析器。</li></ol>
<pre class="prettyprint linenums"><code>http\://dubbo.apache.org/schema/dubbo=org.apache.dubbo.config.spring.schema.DubboNamespaceHandler<br />
http\://code.alibabatech.com/schema/dubbo=org.apache.dubbo.config.spring.schema.DubboNamespaceHandler<br />
</code></pre>
<ol><li><strong>命名空间处理器</strong><br /><br />
命名空间处理器主要用来注册 BeanDefinitionParser 解析器。对应上面 spring.handlers 文件中的 DubboNamespaceHandler</li></ol>
<pre class="prettyprint linenums"><code>public class DubboNamespaceHandler extends NamespaceHandlerSupport {<br />
    @Override<br />
    public void init() {<br />
        registerBeanDefinitionParser(&quot;application&quot;, new DubboBeanDefinitionParser(ApplicationConfig.class, true));<br />
        // 省略...<br />
        registerBeanDefinitionParser(&quot;annotation&quot;, new AnnotationBeanDefinitionParser());<br />
    }<br />
}<br />
</code></pre>
<ol><li><strong>BeanDefinitionParser 解析器</strong><br /><br />
实现 BeanDefinitionParser 接口中的 parse 方法，用于自定义标签的解析。Dubbo 中对应 DubboBeanDefinitionParser 类。</li></ol>
<h2>Dubbo 解析自定义 XML 标签</h2>
<p>终于进入到本文的重头戏环节了。在介绍 Dubbo 自定义 XML 标签解析前，先放一张图帮助大家理解以下 Spring 是如何从 XML 文件中解析并加载 Bean 的。</p>
<p><img referrerpolicy="no-referrer"src="https://user-gold-cdn.xitu.io/2018/12/24/167e087daeb2c573?w=2102&amp;h=1590&amp;f=png&amp;s=369388"><br /><br />
上图言尽于 handler.parse() 方法，如果你仔细看了上文，对 parse() 应该是有印象的。<br /><br />
没错，在前一小结的第五点我们介绍了 DubboBeanDefinitionParser 类。该类有个方法就叫 parse()。那么这个 parse() 方法有什么用？ Spring 是如何感知到我就要调用 DubboBeanDefinitionParser 类中的 parse() 方法的呢？我们带着这两个问题接着往下看。</p>
<h3>BeanDefinitionParserDelegate</h3>
<p>上面图的流程比较长，我们先着重看下 <strong>BeanDefinitionParserDelegate</strong>　类中的几个关键方法。</p>
<pre class="prettyprint linenums"><code>BeanDefinitionParserDelegate.java<br />
public BeanDefinition parseCustomElement(Element ele, BeanDefinition containingBd) {<br />
    // 获取当前 element 的 namespaceURI<br />
    // 比如 dubbo.xsd 中的为 http://dubbo.apache.org/schema/dubbo<br />
    String namespaceUri = this.getNamespaceURI(ele);<br />
    // 根据 URI 获取对应的 NamespaceHandler<br />
    NamespaceHandler handler = this.readerContext.getNamespaceHandlerResolver().resolve(namespaceUri);<br />
    if (handler == null) {<br />
        this.error(&quot;Unable to locate Spring NamespaceHandler for XML schema namespace [&quot; + namespaceUri + &quot;]&quot;, ele);<br />
        return null;<br />
    } else {<br />
        return handler.parse(ele, new ParserContext(this.readerContext, this, containingBd));<br />
    }<br />
}<br />
</code></pre>
<p>这个方法干了三件事</p>
<ol><li>获取 element 元素的 namespaceURI，并据此获取对应的 NamespaceHandler 对象。Dubbo 自定义标签(比如 Dubbo:provider) namespaceUri 的值为 <strong><code>http://dubbo.apache.org/schema/dubbo</code></strong>;</li>
<li>根据 step1 获取到的 namespaceUri ，获取对应的  NamespaceHandler 对象。这里会调用 DefaultNamespaceHandlerResolver 类的 resolve() 方法，我们下面会分析;</li>
<li>调用 handler 的 parse 方法，我们自定以的 handler 会继承 NamespaceHandlerSupport 类，所以这里调用的其实是 NamespaceHandlerSupport 类的 parse() 方法，后文分析；</li></ol>
<p><strong>一图胜千言</strong><br /><br />
在详细分析 step2 和 step3 中涉及的 <strong>resolver()</strong> 和 <strong>parse()</strong> 方法前，先放一张时序图让大家有个基本概念：</p>
<p><img referrerpolicy="no-referrer"src="https://user-gold-cdn.xitu.io/2018/12/18/167c1d44e2e73aea?w=1842&amp;h=862&amp;f=png&amp;s=164969"></p>
<pre class="prettyprint linenums"><code>DefaultNamespaceHandlerResolver.java<br />
public NamespaceHandler resolve(String namespaceUri) {<br />
    Map&lt;String, Object&gt; handlerMappings = this.getHandlerMappings();<br />
    // 以 namespaceUri 为 Key 获取对应的 handlerOrClassName<br />
    Object handlerOrClassName = handlerMappings.get(namespaceUri);<br />
    if (handlerOrClassName == null) {<br />
        return null;<br />
    } else if (handlerOrClassName instanceof NamespaceHandler) {<br />
        return (NamespaceHandler)handlerOrClassName;<br />
    } else {<br />
        // 如果不为空且不为 NamespaceHandler 的实例，转换为 String 类型<br />
        // DubboNamespaceHandler 执行的便是这段逻辑<br />
        String className = (String)handlerOrClassName;

        try {<br />
            Class&lt;?&gt; handlerClass = ClassUtils.forName(className, this.classLoader);<br />
            // handlerClass 是否为 NamespaceHandler 的实现类，若不是则抛出异常<br />
            if (!NamespaceHandler.class.isAssignableFrom(handlerClass)) {<br />
                throw new FatalBeanException(&quot;Class [&quot; + className + &quot;] for namespace [&quot; + namespaceUri + &quot;] does not implement the [&quot; + NamespaceHandler.class.getName() + &quot;] interface&quot;);<br />
            } else {<br />
                // 初始化 handlerClass<br />
                NamespaceHandler namespaceHandler = (NamespaceHandler)BeanUtils.instantiateClass(handlerClass);<br />
                // 执行 handlerClass类的 init() 方法<br />
                namespaceHandler.init();<br />
                handlerMappings.put(namespaceUri, namespaceHandler);<br />
                return namespaceHandler;<br />
            }<br />
        } catch (ClassNotFoundException var7) {<br />
            throw new FatalBeanException(&quot;NamespaceHandler class [&quot; + className + &quot;] for namespace [&quot; + namespaceUri + &quot;] not found&quot;, var7);<br />
        } catch (LinkageError var8) {<br />
            throw new FatalBeanException(&quot;Invalid NamespaceHandler class [&quot; + className + &quot;] for namespace [&quot; + namespaceUri + &quot;]: problem with handler class file or dependent class&quot;, var8);<br />
        }<br />
    }<br />
}<br />
</code></pre>
<p>resolve() 方法用途是根据方法参数中的 namespaceUri 获取对应的 NamespaceHandler 对象。这里会先尝试以 namespaceUri 为 key 去 handlerMappings 集合中取对象。<br /><br />
如果 handlerOrClassName 不为 null 且不为 NamespaceHandler 的实例。那么尝试将 handlerOrClassName 作为 className 并调用 BeanUtils.instantiateClass() 方法初始化一个<br /><br />
NamespaceHandler 实例。初始化后，调用其 init() 方法。这个 init() 方法比较重要，我们接着往下看。</p>
<pre class="prettyprint linenums"><code>DubboNamespaceHandler<br />
public void init() {<br />
    registerBeanDefinitionParser(&quot;application&quot;, new DubboBeanDefinitionParser(ApplicationConfig.class, true));<br />
    registerBeanDefinitionParser(&quot;module&quot;, new DubboBeanDefinitionParser(ModuleConfig.class, true));<br />
    registerBeanDefinitionParser(&quot;registry&quot;, new DubboBeanDefinitionParser(RegistryConfig.class, true));<br />
    registerBeanDefinitionParser(&quot;monitor&quot;, new DubboBeanDefinitionParser(MonitorConfig.class, true));<br />
    registerBeanDefinitionParser(&quot;provider&quot;, new DubboBeanDefinitionParser(ProviderConfig.class, true));<br />
    registerBeanDefinitionParser(&quot;consumer&quot;, new DubboBeanDefinitionParser(ConsumerConfig.class, true));<br />
    registerBeanDefinitionParser(&quot;protocol&quot;, new DubboBeanDefinitionParser(ProtocolConfig.class, true));<br />
    registerBeanDefinitionParser(&quot;service&quot;, new DubboBeanDefinitionParser(ServiceBean.class, true));<br />
    registerBeanDefinitionParser(&quot;reference&quot;, new DubboBeanDefinitionParser(ReferenceBean.class, false));<br />
    registerBeanDefinitionParser(&quot;annotation&quot;, new AnnotationBeanDefinitionParser());<br />
}

NamespaceHandlerSupport<br />
private final Map&lt;String, BeanDefinitionParser&gt; parsers = new HashMap();<br />
protected final void registerBeanDefinitionParser(String elementName, BeanDefinitionParser parser) {<br />
    this.parsers.put(elementName, parser);<br />
}<br />
</code></pre>
<p>DubboNamespaceHandler 类中的 init() 方法干的事情特别简单，就是新建 DubboBeanDefinitionParser 对象并将其放入 NamespaceHandlerSupport 类的 parsers 集合中。我们再回顾一下 parseCustomElement() 方法。</p>
<pre class="prettyprint linenums"><code>BeanDefinitionParserDelegate.java<br />
public BeanDefinition parseCustomElement(Element ele, BeanDefinition containingBd) {<br />
    // 省略...<br />
    return handler.parse(ele, new ParserContext(this.readerContext, this, containingBd));<br />
    // 省略...<br />
}<br />
</code></pre>
<p>这里会调用 NamespaceHandlerSupport 类的 parse() 方法。我们继续跟踪一下。</p>
<pre class="prettyprint linenums"><code>public BeanDefinition parse(Element element, ParserContext parserContext) {<br />
    return this.findParserForElement(element, parserContext).parse(element, parserContext);<br />
}<br />
private BeanDefinitionParser findParserForElement(Element element, ParserContext parserContext) {<br />
    String localName = parserContext.getDelegate().getLocalName(element);<br />
    BeanDefinitionParser parser = (BeanDefinitionParser)this.parsers.get(localName);<br />
    if (parser == null) {<br />
        parserContext.getReaderContext().fatal(&quot;Cannot locate BeanDefinitionParser for element [&quot; + localName + &quot;]&quot;, element);<br />
    }

    return parser;<br />
}<br />
</code></pre>
<p>看到这里大家有没有一丝豁然开朗的感觉？之前的 resolve() 方法实际上就是根据当前 element 的 namespaceURI 获取对应的 NamespaceHandler 对象(对于 Dubbo 来说是 DubboNamespaceHandler)，<br /><br />
然后调用 DubboNamespaceHandler 中的 init() 方法新建 DubboBeanDefinitionParser 对象并注册到 NamespaceHandlerSupport 类的 parsers 集合中。<br /><br />
然后 parser 方法会根据当前 element 对象从 parsers 集合中获取合适的 BeanDefinitionParser 对象。对于 Dubbo 元素来说，实际上最后执行的是 DubboBeanDefinitionParser 的 parse() 方法。</p>
<h2>DubboBeanDefinitionParser.parse()</h2>
<p>最后我们再来看看 Dubbo 解析 XML 文件的详细实现吧。如果对具体实现没有兴趣可直接直接跳过。</p>
<pre class="prettyprint linenums"><code>private static BeanDefinition parse(Element element, ParserContext parserContext, Class&lt;?&gt; beanClass, boolean required) {<br />
        RootBeanDefinition beanDefinition = new RootBeanDefinition();<br />
        beanDefinition.setBeanClass(beanClass);<br />
        beanDefinition.setLazyInit(false);<br />
        String id = element.getAttribute(&quot;id&quot;);<br />
        // DubboBeanDefinitionParser 构造方法中有对 required 值进行初始化；<br />
        // DubboNamespaceHandler 类中的 init 方法会创建并注册 DubboBeanDefinitionParser 类<br />
        if ((id == null || id.length() == 0) &amp;&amp; required) {<br />
            String generatedBeanName = element.getAttribute(&quot;name&quot;);<br />
            if (generatedBeanName == null || generatedBeanName.length() == 0) {<br />
                if (ProtocolConfig.class.equals(beanClass)) {<br />
                    generatedBeanName = &quot;dubbo&quot;;<br />
                } else {<br />
                    // name 属性为空且不为 ProtocolConfig 类型，取 interface 值<br />
                    generatedBeanName = element.getAttribute(&quot;interface&quot;);<br />
                }<br />
            }<br />
            if (generatedBeanName == null || generatedBeanName.length() == 0) {<br />
                // 获取 beanClass 的全限定类名<br />
                generatedBeanName = beanClass.getName();<br />
            }<br />
            id = generatedBeanName;<br />
            int counter = 2;<br />
            while (parserContext.getRegistry().containsBeanDefinition(id)) {<br />
                id = generatedBeanName + (counter++);<br />
            }<br />
        }<br />
        if (id != null &amp;&amp; id.length() &gt; 0) {<br />
            if (parserContext.getRegistry().containsBeanDefinition(id)) {<br />
                throw new IllegalStateException(&quot;Duplicate spring bean id &quot; + id);<br />
            }<br />
            // 注册 beanDefinition<br />
            parserContext.getRegistry().registerBeanDefinition(id, beanDefinition);<br />
            // 为 beanDefinition 添加 id 属性<br />
            beanDefinition.getPropertyValues().addPropertyValue(&quot;id&quot;, id);<br />
        }

        // 如果当前 beanClass 类型为 ProtocolConfig<br />
        // 遍历已经注册过的 bean 对象，如果 bean 对象含有 protocol 属性<br />
        // protocol 属性值为 ProtocolConfig 实例且 name 和当前 id 值一致，为当前 beanClass 对象添加 protocl 属性<br />
        if (ProtocolConfig.class.equals(beanClass)) {<br />
            for (String name : parserContext.getRegistry().getBeanDefinitionNames()) {<br />
                BeanDefinition definition = parserContext.getRegistry().getBeanDefinition(name);<br />
                PropertyValue property = definition.getPropertyValues().getPropertyValue(&quot;protocol&quot;);<br />
                if (property != null) {<br />
                    Object value = property.getValue();<br />
                    if (value instanceof ProtocolConfig &amp;&amp; id.equals(((ProtocolConfig) value).getName())) {<br />
                        definition.getPropertyValues().addPropertyValue(&quot;protocol&quot;, new RuntimeBeanReference(id));<br />
                    }<br />
                }<br />
            }<br />
        } else if (ServiceBean.class.equals(beanClass)) {<br />
            // 如果当前元素包含 class 属性，调用 ReflectUtils.forName() 方法加载类对象<br />
            // 调用 parseProperties 解析其他属性设置到 classDefinition 对象中<br />
            // 最后设置 beanDefinition 的 ref 属性为 BeanDefinitionHolder 包装类<br />
            String className = element.getAttribute(&quot;class&quot;);<br />
            if (className != null &amp;&amp; className.length() &gt; 0) {<br />
                RootBeanDefinition classDefinition = new RootBeanDefinition();<br />
                classDefinition.setBeanClass(ReflectUtils.forName(className));<br />
                classDefinition.setLazyInit(false);<br />
                parseProperties(element.getChildNodes(), classDefinition);<br />
                beanDefinition.getPropertyValues().addPropertyValue(&quot;ref&quot;, new BeanDefinitionHolder(classDefinition, id + &quot;Impl&quot;));<br />
            }<br />
        } else if (ProviderConfig.class.equals(beanClass)) {<br />
            parseNested(element, parserContext, ServiceBean.class, true, &quot;service&quot;, &quot;provider&quot;, id, beanDefinition);<br />
        } else if (ConsumerConfig.class.equals(beanClass)) {<br />
            parseNested(element, parserContext, ReferenceBean.class, false, &quot;reference&quot;, &quot;consumer&quot;, id, beanDefinition);<br />
        }<br />
        Set&lt;String&gt; props = new HashSet&lt;String&gt;();<br />
        ManagedMap parameters = null;<br />
        for (Method setter : beanClass.getMethods()) {<br />
            String name = setter.getName();<br />
            if (name.length() &gt; 3 &amp;&amp; name.startsWith(&quot;set&quot;)<br />
                    &amp;&amp; Modifier.isPublic(setter.getModifiers())<br />
                    &amp;&amp; setter.getParameterTypes().length == 1) {<br />
                Class&lt;?&gt; type = setter.getParameterTypes()[0];<br />
                String propertyName = name.substring(3, 4).toLowerCase() + name.substring(4);<br />
                String property = StringUtils.camelToSplitName(propertyName, &quot;-&quot;);<br />
                props.add(property);<br />
                Method getter = null;<br />
                try {<br />
                    getter = beanClass.getMethod(&quot;get&quot; + name.substring(3), new Class&lt;?&gt;[0]);<br />
                } catch (NoSuchMethodException e) {<br />
                    try {<br />
                        getter = beanClass.getMethod(&quot;is&quot; + name.substring(3), new Class&lt;?&gt;[0]);<br />
                    } catch (NoSuchMethodException e2) {<br />
                    }<br />
                }<br />
                if (getter == null<br />
                        || !Modifier.isPublic(getter.getModifiers())<br />
                        || !type.equals(getter.getReturnType())) {<br />
                    continue;<br />
                }<br />
                if (&quot;parameters&quot;.equals(property)) {<br />
                    parameters = parseParameters(element.getChildNodes(), beanDefinition);<br />
                } else if (&quot;methods&quot;.equals(property)) {<br />
                    parseMethods(id, element.getChildNodes(), beanDefinition, parserContext);<br />
                } else if (&quot;arguments&quot;.equals(property)) {<br />
                    parseArguments(id, element.getChildNodes(), beanDefinition, parserContext);<br />
                } else {<br />
                    String value = element.getAttribute(property);<br />
                    if (value != null) {<br />
                        value = value.trim();<br />
                        if (value.length() &gt; 0) {<br />
                        // 如果属性为 registry，且 registry 属性的值为&quot;N/A&quot;，标识不会注册到任何注册中心<br />
                        // 新建 RegistryConfig 并将其设置为 beanDefinition 的 registry 属性<br />
                            if (&quot;registry&quot;.equals(property) &amp;&amp; RegistryConfig.NO_AVAILABLE.equalsIgnoreCase(value)) {<br />
                                RegistryConfig registryConfig = new RegistryConfig();<br />
                                registryConfig.setAddress(RegistryConfig.NO_AVAILABLE);<br />
                                beanDefinition.getPropertyValues().addPropertyValue(property, registryConfig);<br />
                            } else if (&quot;registry&quot;.equals(property) &amp;&amp; value.indexOf(',') != -1) {<br />
                                // 多注册中心解析<br />
                                parseMultiRef(&quot;registries&quot;, value, beanDefinition, parserContext);<br />
                            } else if (&quot;provider&quot;.equals(property) &amp;&amp; value.indexOf(',') != -1) {<br />
                                parseMultiRef(&quot;providers&quot;, value, beanDefinition, parserContext);<br />
                            } else if (&quot;protocol&quot;.equals(property) &amp;&amp; value.indexOf(',') != -1) {<br />
                                // 多协议<br />
                                parseMultiRef(&quot;protocols&quot;, value, beanDefinition, parserContext);<br />
                            } else {<br />
                                Object reference;<br />
                                if (isPrimitive(type)) {<br />
                                    // type 为方法参数，type 类型是否为基本类型<br />
                                    if (&quot;async&quot;.equals(property) &amp;&amp; &quot;false&quot;.equals(value)<br />
                                            || &quot;timeout&quot;.equals(property) &amp;&amp; &quot;0&quot;.equals(value)<br />
                                            || &quot;delay&quot;.equals(property) &amp;&amp; &quot;0&quot;.equals(value)<br />
                                            || &quot;version&quot;.equals(property) &amp;&amp; &quot;0.0.0&quot;.equals(value)<br />
                                            || &quot;stat&quot;.equals(property) &amp;&amp; &quot;-1&quot;.equals(value)<br />
                                            || &quot;reliable&quot;.equals(property) &amp;&amp; &quot;false&quot;.equals(value)) {<br />
                                        // 新老版本 xsd 兼容性处理<br />
                                        // backward compatibility for the default value in old version's xsd<br />
                                        value = null;<br />
                                    }<br />
                                    reference = value;<br />
                                } else if (&quot;protocol&quot;.equals(property)<br />
                                        &amp;&amp; ExtensionLoader.getExtensionLoader(Protocol.class).hasExtension(value)<br />
                                        &amp;&amp; (!parserContext.getRegistry().containsBeanDefinition(value)<br />
                                        || !ProtocolConfig.class.getName().equals(parserContext.getRegistry().getBeanDefinition(value).getBeanClassName()))) {<br />
                                    // 如果 protocol 属性值有对应的扩展实现，而且没有被注册到 spring 注册表中<br />
                                    // 或者 spring 注册表中对应的 bean 的类型不为 ProtocolConfig.class<br />
                                    if (&quot;dubbo:provider&quot;.equals(element.getTagName())) {<br />
                                        logger.warn(&quot;Recommended replace &lt;dubbo:provider protocol=\&quot;&quot; + value + &quot;\&quot; ... /&gt; to &lt;dubbo:protocol name=\&quot;&quot; + value + &quot;\&quot; ... /&gt;&quot;);<br />
                                    }<br />
                                    // backward compatibility<br />
                                    ProtocolConfig protocol = new ProtocolConfig();<br />
                                    protocol.setName(value);<br />
                                    reference = protocol;<br />
                                } else if (&quot;onreturn&quot;.equals(property)) {<br />
                                    int index = value.lastIndexOf(&quot;.&quot;);<br />
                                    String returnRef = value.substring(0, index);<br />
                                    String returnMethod = value.substring(index + 1);<br />
                                    reference = new RuntimeBeanReference(returnRef);<br />
                                    beanDefinition.getPropertyValues().addPropertyValue(&quot;onreturnMethod&quot;, returnMethod);<br />
                                } else if (&quot;onthrow&quot;.equals(property)) {<br />
                                    int index = value.lastIndexOf(&quot;.&quot;);<br />
                                    String throwRef = value.substring(0, index);<br />
                                    String throwMethod = value.substring(index + 1);<br />
                                    reference = new RuntimeBeanReference(throwRef);<br />
                                    beanDefinition.getPropertyValues().addPropertyValue(&quot;onthrowMethod&quot;, throwMethod);<br />
                                } else if (&quot;oninvoke&quot;.equals(property)) {<br />
                                    int index = value.lastIndexOf(&quot;.&quot;);<br />
                                    String invokeRef = value.substring(0, index);<br />
                                    String invokeRefMethod = value.substring(index + 1);<br />
                                    reference = new RuntimeBeanReference(invokeRef);<br />
                                    beanDefinition.getPropertyValues().addPropertyValue(&quot;oninvokeMethod&quot;, invokeRefMethod);<br />
                                } else {<br />
                                    // 如果 ref 属性值已经被注册到 spring 注册表中<br />
                                    if (&quot;ref&quot;.equals(property) &amp;&amp; parserContext.getRegistry().containsBeanDefinition(value)) {<br />
                                        BeanDefinition refBean = parserContext.getRegistry().getBeanDefinition(value);<br />
                                        // 非单例抛出异常<br />
                                        if (!refBean.isSingleton()) {<br />
                                            throw new IllegalStateException(&quot;The exported service ref &quot; + value + &quot; must be singleton! Please set the &quot; + value + &quot; bean scope to singleton, eg: &lt;bean id=\&quot;&quot; + value + &quot;\&quot; scope=\&quot;singleton\&quot; ...&gt;&quot;);<br />
                                        }<br />
                                    }<br />
                                    reference = new RuntimeBeanReference(value);<br />
                                }<br />
                                beanDefinition.getPropertyValues().addPropertyValue(propertyName, reference);<br />
                            }<br />
                        }<br />
                    }<br />
                }<br />
            }<br />
        }<br />
        NamedNodeMap attributes = element.getAttributes();<br />
        int len = attributes.getLength();<br />
        for (int i = 0; i &lt; len; i++) {<br />
            Node node = attributes.item(i);<br />
            String name = node.getLocalName();<br />
            if (!props.contains(name)) {<br />
                if (parameters == null) {<br />
                    parameters = new ManagedMap();<br />
                }<br />
                String value = node.getNodeValue();<br />
                parameters.put(name, new TypedStringValue(value, String.class));<br />
            }<br />
        }<br />
        if (parameters != null) {<br />
            beanDefinition.getPropertyValues().addPropertyValue(&quot;parameters&quot;, parameters);<br />
        }<br />
        return beanDefinition;<br />
    }<br />
</code></pre>
<p><strong>上面这一大段关于配置的解析的代码需要大家自己结合实际的代码进行调试才能更好的理解。我在理解 Dubbo XML 解析的时候，也是耐着性子一遍一遍的来。</strong><br /><br />
关于 ProtocolConfig 和 protocol 加载先后顺序的问题最后再集合一个小例子总结下吧：</p>
<pre class="prettyprint linenums"><code>    dubbo-demo-provider.xml<br />
    &lt;dubbo:protocol name=&quot;dubbo&quot; port=&quot;20880&quot;/&gt;<br />
</code></pre>
<ol><li>当我们先解析了 ProtocolConfig 元素时，我们会遍历所有已经注册 spring 注册表中 bean。如果 bean 对象存在 protocol 属性且与 name 和当前 ProtolConfig id 匹配，则会新建 RuntimeBeanReference 对象覆盖 protocol 属性。对于上面这行配置，最后会新建一个拥有 name 和 port 的 beanDefinition 对象。</li>
<li>先解析了 protocol 元素，ProtocolConfig 未被解析。此时我们在 spring 注册表中找不到对应的 ProtocolConfig bean。此时我们将需要新建一个 ProtocolConfig 并将其 name 属性<br /><br />
设置为当前属性值。最后将其设置为 beanDefinition 对象的 protocol 属性。后面加载到了 ProtocolConfig 元素时，会替换 protocol 的值。</li></ol>
<h2>End</h2>
<p>Dubbo 对于自定义 XML 标签的定义和解析实际上借助了 Spring 框架对自定义 XML 标签的支持。本篇水文虽然又臭又长，但是对于理解 Dubbo 的初始化过程还是很重要的。后面我们会介绍关于 Dubbo 服务暴露相关内容。</p>
<blockquote><p>本BLOG上原创文章未经本人许可，不得用于商业用途及传统媒体。网络媒体转载请注明出处，否则属于侵权行为。<strong><code>https://juejin.im/post/5c1753b65188250850604ebe</code></strong></p></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2w22wq.html">angularJS（3）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8konv5q.html">android中的线程池学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwyj7y8.html">Introduction of Team Member</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zz1lx8.html">剑指offer习题集1</a>
		</li>
						<li><a href="https://www.batexi.com/a/r930y7g9.html">android之listview</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmmd1l9.html">Docker-数据卷和数据容器卷</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjd0149.html">android图像处理系列之三－－图片色调饱和度、色相、亮度处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxne3mv8.html">IEEE 802&period;15&period;4协议学习之物理层</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvyxgyq.html">网页、php脚本的编码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde77mv9.html">&lbrack;Immutable &plus; AngularJS&rsqb; Use Immutable &period;List&lpar;&rpar; for Angular array</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x24me8.html">JSP九大内置对象和四种属性范围解读</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnoen6q.html">Redis用户添加、分页、登录、注册、加关注案例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1514oq.html">js静态方法和实例方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zxw1g9.html">LGPL与闭源程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp0x739.html">清华集训2014 day2 task1 简单回路</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ze51g9.html">zoj 1718 poj 2031 Building a Space Station</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj0pnk8.html">python小练习（自己瞎倒腾）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdxm4v9.html">MySQL-如何删除hash表分区</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvelkjo9.html">WCF已超过传入消息&lpar;65536&rpar;的最大消息大小配额。若要增加配额，请使用相应绑定元素上的 MaxReceivedMessageSize 属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/9536ogv8.html">ant design pro （三）路由和菜单</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90244mjq.html">js原生实现轮播</a>
			</li>
						<li><a href="https://www.batexi.com/a/963lldv9.html">org&period;springframework&period;data&period;redis&period;cache&period;RedisCacheManager</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnng41xq.html">centos7 安装mariadb最新版并配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmvd5l9.html">为什么选用 React 创建混合型移动应用？</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjgxo7q.html">10&period;Spring&mdash;&mdash;框架的AOP</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnng0z2q.html">asp&period;net --- reponse对象写图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1w2719.html">解决tableView中cell动态加载控件的重用问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpz0y09.html">DES加密（支持ARC与MRC）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e2wkk9.html">WeakValue &amp;amp&semi; StoreValue</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmvrkl9.html">可以简易设置文字内边距的EdgeInsetsLabel</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
